//#define debug(x) OutputDebugString(x)
#define debug(x)
#define makehook(x) MH_CreateHook(&(x), &(my_##x), (void **)&(orig_##x))
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <MinHook.h>
#ifndef DEBUG
void inline __cdecl odprintf(const char *format, ...) {}
void inline __cdecl odprintfW(const wchar_t *format, ...) {}
#else
void __cdecl odprintf(const char *format, ...)
{
char    buf[4096], *p = buf;
va_list args;
int     n;

        va_start(args, format);
        n = _vsnprintf(p, sizeof buf - 3, format, args); // buf-3 is room for CR/LF/NUL
        va_end(args);

        OutputDebugString(buf);
}
void __cdecl odprintfW(const wchar_t *format, ...)
{
wchar_t    buf[4096], *p = buf;
va_list args;
int     n;

        va_start(args, format);
        n = _vsnwprintf(p, sizeof buf - 3, format, args); // buf-3 is room for CR/LF/NUL
        va_end(args);

        OutputDebugStringW((wchar_t *)buf);
}
#endif

//handle for the currently opened midi device.
HMIDIOUT g_handle = 0;
HMIDISTRM g_stream = 0;
typedef MMRESULT (WINAPI *fpmidiOutClose) (HMIDIOUT);
MMRESULT WINAPI my_midiOutClose(HMIDIOUT hmo);
typedef BOOL (WINAPI *fpCloseClipboard)(void);
fpCloseClipboard orig_CloseClipboard = NULL;
BOOL WINAPI my_CloseClipboard(void);
MCIERROR WINAPI my_mciSendStringA (LPCTSTR lpszCommand,
  LPTSTR lpszReturnString,
  UINT cchReturn,
  HANDLE hwndCallback);
typedef MMRESULT (WINAPI *fpmidiOutOpen)(LPHMIDIOUT, UINT, DWORD_PTR, DWORD_PTR, DWORD);
typedef MCIERROR (WINAPI *fpmciSendString) (LPCTSTR lpszCommand,
  LPTSTR lpszReturnString,
  UINT cchReturn,
  HANDLE hwndCallback);
fpmidiOutOpen orig_midiOutOpen = NULL;
fpmciSendString orig_mciSendStringA = NULL;
fpmidiOutClose orig_midiOutClose = NULL;
MMRESULT WINAPI my_midiOutOpen(
  LPHMIDIOUT lphmo,
  UINT uDeviceID,
  DWORD_PTR dwCallback,
  DWORD_PTR dwCallbackInstance,
  DWORD dwFlags);
MMRESULT WINAPI my_midiStreamOpen(LPHMIDISTRM lphStream, LPUINT puDeviceID, DWORD cMidi, DWORD_PTR dwCallback, DWORD_PTR dwInstance, DWORD fdwOpen);
typedef MMRESULT (WINAPI *fpmidiStreamOpen)(LPHMIDISTRM lphStream, LPUINT puDeviceID, DWORD cMidi, DWORD_PTR dwCallback, DWORD_PTR dwInstance, DWORD fdwOpen);
fpmidiStreamOpen orig_midiStreamOpen = NULL;
typedef MMRESULT (WINAPI *fpmidiStreamClose) (HMIDISTRM);
fpmidiStreamClose orig_midiStreamClose = NULL;
MMRESULT WINAPI my_midiStreamClose(HMIDISTRM hStream);
void CALLBACK MidiOutProc (HMIDIOUT hmo, UINT wMsg, DWORD_PTR dwInstance, DWORD_PTR dwParam1, DWORD_PTR dwParam2);
typedef void (CALLBACK *fpMidiOutProc) (HMIDIOUT hmo, UINT wMsg, DWORD_PTR dwInstance, DWORD_PTR dwParam1, DWORD_PTR dwParam2);
DWORD_PTR g_instance = NULL;
fpMidiOutProc orig_callback = NULL;
DWORD our_pid;
typedef short (WINAPI *fpGetAsyncKeyState) (int vKey);
fpGetAsyncKeyState orig_GetAsyncKeyState = NULL;
short WINAPI my_GetAsyncKeyState(int vKey);

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved) {

switch (fdwReason) {
case DLL_PROCESS_ATTACH:
our_pid = GetCurrentProcessId();
if (MH_Initialize() != MH_OK) return FALSE;
makehook(mciSendStringA);
makehook(CloseClipboard);
makehook(midiStreamOpen);
makehook(midiStreamClose);
makehook(GetAsyncKeyState);
MH_EnableAllHooks();
break;
}
return TRUE;
}

MCIERROR WINAPI my_mciSendStringA (LPCTSTR lpszCommand,
  LPTSTR lpszReturnString,
  UINT cchReturn,
  HANDLE hwndCallback)
{
MCIERROR res;
char buf[4096];
sprintf(buf, "%s", lpszCommand);
char *c;
c = (char *)strstr((const char *)lpszCommand, "open");
if (c) {
debug("open found");
if ((char *)strstr((const char *)lpszCommand, "mpegvideo")) goto skip;
sprintf(buf, "%s type mpegvideo", lpszCommand);
}
skip:
debug(buf);
res = orig_mciSendStringA(buf, lpszReturnString, cchReturn, hwndCallback);
debug("mciSendStringA done");
return res;
}

MMRESULT WINAPI my_midiOutOpen(
  LPHMIDIOUT lphmo,
  UINT uDeviceID,
  DWORD_PTR dwCallback,
  DWORD_PTR dwCallbackInstance,
  DWORD dwFlags)
{
char buf[1024];
MMRESULT res;
sprintf(buf, "dev %d flags %d", uDeviceID, dwFlags);
debug(buf);
if (uDeviceID == -1) {
//We're opening the midi mapper. If we already have it open, keep it and just return the handle.
if (g_handle != 0) {
*lphmo = g_handle;
orig_callback = (fpMidiOutProc)dwCallback;
g_instance = dwCallbackInstance;
return 0;
}
else {
orig_callback = (fpMidiOutProc)dwCallback;
g_instance = dwCallbackInstance;
res = orig_midiOutOpen(lphmo, uDeviceID, (DWORD_PTR)MidiOutProc, dwCallbackInstance, dwFlags);
g_handle = *lphmo;
return res;
}
}
res = orig_midiOutOpen(lphmo, uDeviceID, dwCallback, dwCallbackInstance, dwFlags);
debug("midiOutOpen done");
return res;
} // function

MMRESULT WINAPI my_midiOutClose(HMIDIOUT hmo)
{
if (hmo != g_handle) {
debug("close");
return orig_midiOutClose(hmo);
}
midiOutReset(hmo);
//0x000079b0
return 0;
}

BOOL WINAPI my_CloseClipboard(void)
{
HGLOBAL mem;
mem = GlobalAlloc(GMEM_MOVEABLE, 4);
int *locale = (int *)GlobalLock(mem);
*locale = 0x0411;
GlobalUnlock(mem);
SetClipboardData(CF_LOCALE, mem);
return orig_CloseClipboard();
}

MMRESULT WINAPI my_midiStreamOpen(LPHMIDISTRM lphStream, LPUINT puDeviceID, DWORD cMidi, DWORD_PTR dwCallback, DWORD_PTR dwInstance, DWORD fdwOpen) {
MMRESULT res;
char buf[1024];
sprintf(buf, "midi stream open: %d callback %d dwInstance %d fdwOpen %d", *puDeviceID, dwCallback, dwInstance, fdwOpen);
debug(buf);
if (!g_stream) {
debug("no stream, opening one");
orig_callback = (fpMidiOutProc)dwCallback;
g_instance = dwInstance;
res = orig_midiStreamOpen(lphStream, puDeviceID, cMidi, (DWORD_PTR)MidiOutProc, dwInstance, fdwOpen);
g_stream = *lphStream;
return res;
}
else {
debug("returning old stream, resetting callback/instance");
*lphStream = g_stream;
orig_callback = (fpMidiOutProc)dwCallback;
g_instance = dwInstance;
return 0;
}
}

MMRESULT WINAPI my_midiStreamClose(HMIDISTRM hStream)
{
midiOutReset((HMIDIOUT)g_stream);
debug("midi stream close");
return 0;
}

void CALLBACK MidiOutProc (HMIDIOUT hmo, UINT wMsg, DWORD_PTR dwInstance, DWORD_PTR dwParam1, DWORD_PTR dwParam2)
{
// call the old callback with the saved instance data
orig_callback(hmo, wMsg, g_instance, dwParam1, dwParam2);
}
short WINAPI my_GetAsyncKeyState(int vKey)
{
DWORD pid = 0;
GetWindowThreadProcessId(GetForegroundWindow(), &pid);
if (pid == our_pid)
return orig_GetAsyncKeyState(vKey);
return 0;
}